<?php

namespace App\Apiconnect\Api;

use mysql_xdevapi\Exception;
use Phalcon\Events\Event;

/**
 * Token helper for APi
 */
class Token extends \App\Apiconnect\Api\Base
{
    protected $_component = 'Token';

    /**
     * fetches access token from marketplace
     *
     * @param [array] $data
     * @return array
     */
    public function get($data)
    {
        $data = $this->di->getObjectManager()->create('\App\Apiconnect\Models\Apps\Shop')
            ->getById($data['shop_id']);
        if ($data) {
            $appConfig = $this->di->getRegistry()->getAppConfig();
            $credentials = $this->getCredentials($appConfig);
            $response = $this->getComponent()->get($data);
            if (isset($response['access_token'])) {
                return [
                    'success' => true,
                    'data' => $response
                ];
            } else {
                return [
                    'success' => false,
                    'data' => $response,
                    'message' => 'Token fetch failed'
                ];
            }
        }
    }
}
