<?php

namespace App\Connector\Components\AI;

use App\Core\Models\BaseMongo;

class Validation extends BaseMongo
{
       public function validateText($data){
        if(isset($data['text']) && gettype($data['text'])==='array' && count($data['text'])){
            $list = [];
            foreach($data['text'] as $k=>$v){
                $list[$k]=[];
                $textToCompare = strtolower(trim($v));
                foreach($this->restrictedWords as $val){
                    if (strpos($textToCompare,$val ) !== false) {
                        $list[$k][]=$v;
                    }
                }
            }
            return ['success'=>true,'restricted_words'=>$list];
        }
        return ['success'=>false,"message"=>"please provide text to validate on."];
    }

    public $restrictedWords = [
        "100% natural" => "100% natural",
        "100% quality guaranteed" => "100% quality guaranteed",
        "acquired immune deficiency syndrome" => "acquired immune deficiency syndrome",
        "add" => "add",
        "added value" => "added value",
        "adhd" => "adhd",
        "aids" => "aids",
        "all natural" => "all natural",
        "als" => "als",
        "alzheimers" => "alzheimers",
        "antibacterial" => "antibacterial",
        "anti-bacterial" => "anti-bacterial",
        "antifungal" => "antifungal",
        "anti-fungal" => "anti-fungal",
        "anti-microbial" => "anti-microbial",
        "anxiety" => "anxiety",
        "approved" => "approved",
        "arrive faster" => "arrive faster",
        "attention deficit disorder drug" => "attention deficit disorder drug",
        "authentic" => "authentic",
        "award winning" => "award winning",
        "bacteria" => "bacteria",
        "best deal" => "best deal",
        "best price" => "best price",
        "best seller" => "best seller",
        "best selling" => "best selling",
        "big sale" => "big sale",
        "biodegradable" => "biodegradable",
        "biological contaminants" => "biological contaminants",
        "bpa free" => "bpa free",
        "brand new" => "brand new",
        "buy now" => "buy now",
        "buy with confidence" => "buy with confidence",
        "cancer" => "cancer",
        "cancroid" => "cancroid",
        "cataract" => "cataract",
        "certified" => "certified",
        "chlamydia" => "chlamydia",
        "closeout" => "closeout",
        "close-out" => "close-out",
        "cmv" => "cmv",
        "compostable" => "compostable",
        "concusuion" => "concusuion",
        "coronavirus" => "coronavirus",
        "covid" => "covid",
        "covid-19" => "covid-19",
        "crabs" => "crabs",
        "crystic fibrosis" => "crystic fibrosis",
        "cure" => "cure",
        "cytomegalovirus" => "cytomegalovirus",
        "decomposable" => "decomposable",
        "degradable" => "degradable",
        "dementia" => "dementia",
        "depression" => "depression",
        "detoxification" => "detoxification",
        "detoxify" => "detoxify",
        "diabetes" => "diabetes",
        "diabetic" => "diabetic",
        "diabetic neuropathy" => "diabetic neuropathy",
        "discounted price" => "discounted price",
        "disease" => "disease",
        "diseases" => "diseases",
        "don’t miss out" => "don’t miss out",
        "dotoxifying" => "dotoxifying",
        "eco friendly" => "eco friendly",
        "ecofriendly" => "ecofriendly",
        "eco-friendly" => "eco-friendly",
        "environmentally friendly" => "environmentally friendly",
        "etc." => "etc.",
        "fall sale" => "fall sale",
        "fda" => "fda",
        "fda approval" => "fda approval",
        "fedex" => "fedex",
        "filter" => "filter",
        "flawless" => "flawless",
        "flu" => "flu",
        "free gift" => "free gift",
        "free shipping" => "free shipping",
        "free shipping guaranteed" => "free shipping guaranteed",
        "fungal" => "fungal",
        "fungicide" => "fungicide",
        "fungicides" => "fungicides",
        "fungus" => "fungus",
        "gift idea" => "gift idea",
        "glaucoma" => "glaucoma",
        "gororrhea" => "gororrhea",
        "great as" => "great as",
        "great for" => "great for",
        "green" => "green",
        "guarantee" => "guarantee",
        "guaranteed" => "guaranteed",
        "hassle free" => "hassle free",
        "heal" => "heal",
        "hepatitis a" => "hepatitis a",
        "hepatitis b" => "hepatitis b",
        "hepatitis c" => "hepatitis c",
        "herpes" => "herpes",
        "herpes simplex virus 1" => "herpes simplex virus 1",
        "herpes simplex virus 2" => "herpes simplex virus 2",
        "highest rated" => "highest rated",
        "hiv" => "hiv",
        "hodgkins lymphoma" => "hodgkins lymphoma",
        "home compostable" => "home compostable",
        "hot item" => "hot item",
        "hpv" => "hpv",
        "hsv1" => "hsv1",
        "hsv2" => "hsv2",
        "huge sale" => "huge sale",
        "human immunodeficiency virus" => "human immunodeficiency virus",
        "human papiloma virus" => "human papiloma virus",
        "imported from" => "imported from",
        "indian" => "indian",
        "inflammation" => "inflammation",
        "influenza" => "influenza",
        "kidney disease" => "kidney disease",
        "lasting quality" => "lasting quality",
        "lgv" => "lgv",
        "limited time offer" => "limited time offer",
        "liver disease" => "liver disease",
        "lupus" => "lupus",
        "lymphogranuloma venereum" => "lymphogranuloma venereum",
        "lymphoma" => "lymphoma",
        "made in" => "made in",
        "mail rebate" => "mail rebate",
        "make excellent" => "make excellent",
        "makes awesome" => "makes awesome",
        "makes great" => "makes great",
        "makes perfect" => "makes perfect",
        "makes spectacular" => "makes spectacular",
        "makes the best" => "makes the best",
        "makes wonderful" => "makes wonderful",
        "marine degradable" => "marine degradable",
        "massive sale" => "massive sale",
        "meningitis" => "meningitis",
        "mildew" => "mildew",
        "money back guarantee" => "money back guarantee",
        "mono" => "mono",
        "mononucleosis" => "mononucleosis",
        "mould" => "mould",
        "mould resistant" => "mould resistant",
        "mould spores" => "mould spores",
        "multiple sclerosis" => "multiple sclerosis",
        "muscular dystrophy" => "muscular dystrophy",
        "mycoplasma genitalium" => "mycoplasma genitalium",
        "nano silver" => "nano silver",
        "native american" => "native american",
        "native american indian or tribes" => "native american indian or tribes",
        "natural" => "natural",
        "newest version" => "newest version",
        "ngu" => "ngu",
        "non toxic" => "non toxic",
        "noncorrosive" => "noncorrosive",
        "nongonococcal urethritis" => "nongonococcal urethritis",
        "non-toxi" => "non-toxi",
        "non-toxic" => "non-toxic",
        "now together" => "now together",
        "on sale" => "on sale",
        "over- stock" => "over- stock",
        "overstock" => "overstock",
        "parasitic" => "parasitic",
        "parkinson" => "parkinson",
        "parkinsons" => "parkinsons",
        "patented" => "patented",
        "peal" => "peal",
        "pelvic inflammatory disease" => "pelvic inflammatory disease",
        "perfect for" => "perfect for",
        "perfect gift" => "perfect gift",
        "pesticide" => "pesticide",
        "pesticides" => "pesticides",
        "pid" => "pid",
        "platinum" => "platinum",
        "plus free" => "plus free",
        "professional quality" => "professional quality",
        "proven" => "proven",
        "public lice" => "public lice",
        "quality" => "quality",
        "ready to ship" => "ready to ship",
        "recommended by" => "recommended by",
        "remedies" => "remedies",
        "remedy" => "remedy",
        "retail box" => "retail box",
        "sad" => "sad",
        "sad" => "sad",
        "sanitize" => "sanitize",
        "sanitizes" => "sanitizes",
        "satisfaction" => "satisfaction",
        "save $" => "save $",
        "save cash" => "save cash",
        "save money" => "save money",
        "scabies" => "scabies",
        "seasonal affective disorder" => "seasonal affective disorder",
        "seen on tv" => "seen on tv",
        "ships faster" => "ships faster",
        "shop with confidence" => "shop with confidence",
        "special offer" => "special offer",
        "special promo" => "special promo",
        "spring sale" => "spring sale",
        "stroke" => "stroke",
        "stroke" => "stroke",
        "summer sale" => "summer sale",
        "super sale" => "super sale",
        "supplies won’t last" => "supplies won’t last",
        "tbis" => "tbis",
        "tbis" => "tbis",
        "tested" => "tested",
        "tested" => "tested",
        "the clap" => "the clap",
        "the clap" => "the clap",
        "top notch" => "top notch",
        "top quality" => "top quality",
        "top rated" => "top rated",
        "top selling" => "top selling",
        "toxic" => "toxic",
        "toxin" => "toxin",
        "toxins" => "toxins",
        "traumatic brain injuries" => "traumatic brain injuries",
        "treat" => "treat",
        "treatment" => "treatment",
        "tribes" => "tribes",
        "trich" => "trich",
        "trichomoniasis" => "trichomoniasis",
        "tricht" => "tricht",
        "tumor" => "tumor",
        "unbeatable price" => "unbeatable price",
        "ups" => "ups",
        "used" => "used",
        "validated" => "validated",
        "viral" => "viral",
        "virus" => "virus",
        "viruses" => "viruses",
        "weight loss" => "weight loss",
        "wholesale price" => "wholesale price",
        "winter sale" => "winter sale",
        "within hours" => "within hours",
        "worlds best" => "worlds best"
    ];
}