<?php

/**
 * CedCommerce
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the End User License Agreement (EULA)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://cedcommerce.com/license-agreement.txt
 *
 * @category    Ced
 * @package     Ced_2.3
 * @author      CedCommerce Core Team <connect@cedcommerce.com>
 * @copyright   Copyright © 2019 CedCommerce. All rights reserved.
 * @license     EULA http://cedcommerce.com/license-agreement.txt
 */

namespace Amazon\Sdk\Api\Report\Header;

class Listing
{
    // TODO: Continue
    public $headers = [
        // ATVPDKIKX0DER -> US
        // A2EUQ1WTGCTBG2 -> CA
        // A1AM78C64UM0Y8 -> MX
        "en_US" => [
            "amazon-order-id",
            "merchant-order-id",
            "purchase-date",
            "last-updated-date",
            "order-status",
            "fulfillment-channel",
            "sales-channel",
            "order-channel",
            "url",
            "ship-service-level",
            "product-name",
            "sku",
            "asin",
            "item-status",
            "quantity",
            "currency",
            "item-price",
            "item-tax",
            "shipping-price",
            "shipping-tax",
            "gift-wrap-price",
            "gift-wrap-tax",
            "item-promotion-discount",
            "ship-promotion-discount",
            "ship-city",
            "ship-state",
            "ship-postal-code",
            "ship-country",
            "promotion-ids",
            "is-business-order",
            "purchase-order-number",
            "price-designation"
        ],
        // A1F83G8C2ARO7P -> UK
        "en_GB" => [
            "item-name",
            "item-description",
            "listing-id",
            "seller-sku",
            "price",
            "quantity",
            "open-date",
            "image-url",
            "item-is-marketplace",
            "product-id-type",
            "zshop-shipping-fee",
            "item-note",
            "item-condition",
            "zshop-category1",
            "zshop-browse-path",
            "zshop-storefront-feature",
            "asin1",
            "asin2",
            "asin3",
            "will-ship-internationally",
            "expedited-shipping",
            "zshop-boldface",
            "product-id",
            "bid-for-featured-placement",
            "add-delete",
            "pending-quantity",
            "fulfillment-channel",
            "merchant-shipping-group",
            "status"
        ],
        // APJ6JRA9NG5V4 -> IT
        "it_IT" => [
            "Nome dell'articolo",
            "Descrizione dell'articolo",
            "Numero offerta",
            "SKU venditore",
            "Prezzo",
            "Quantità",
            "Data di creazione",
            "Non in uso",
            "Articolo per la vendita",
            "Tipo di identificativo del prodotto",
            "Non in uso",
            "Note sull'articolo",
            "Condizione dell'articolo",
            "Non in uso",
            "Non in uso",
            "Non in uso",
            "ASIN 1",
            "Non in uso",
            "Non in uso",
            "Spedizione internazionale",
            "Spedizione Express",
            "Non in uso",
            "Identificativo del prodotto",
            "Non in uso",
            "Aggiungi o elimina",
            "Quantità in sospeso",
            "Canale di gestione",
            "gruppo-spedizione-venditore",
            "stato"
        ],
        // A1PA6795UKMFR9 => DE -> en
        "en_DE" => [
            "item-name",
            "item-description",
            "listing-id",
            "seller-sku",
            "price",
            "quantity",
            "open-date",
            "image-url",
            "item-is-marketplace",
            "product-id-type",
            "zshop-shipping-fee",
            "item-note",
            "item-condition",
            "zshop-category1",
            "zshop-browse-path",
            "zshop-storefront-feature",
            "asin1",
            "asin2",
            "asin3",
            "will-ship-internationally",
            "expedited-shipping",
            "zshop-boldface",
            "product-id",
            "bid-for-featured-placement",
            "add-delete",
            "pending-quantity",
            "fulfillment-channel",
            "merchant-shipping-group",
            "status"
        ]
    ];
}
