<?php

/**
 * CedCommerce
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the End User License Agreement (EULA)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://cedcommerce.com/license-agreement.txt
 *
 * @category    Ced
 * @package     Ced_Amazon
 * @author      CedCommerce Core Team <connect@cedcommerce.com>
 * @copyright   Copyright © 2019 CedCommerce. All rights reserved.
 * @license     EULA http://cedcommerce.com/license-agreement.txt
 */

namespace Amazon\Sdk\Api\Data;

use DateTimeInterface;

interface PingResultInterface extends DataInterface
{
    const FIELD_TIMESTAMP = "timestamp";
    const FIELD_STATUS = "status";

    const STATUS_ACTIVE = true;
    const STATUS_INACTIVE = false;

    /**
     * Get Timestamp
     * @return DateTimeInterface
     */
    public function getTimestamp();

    /**
     * Set Timestamp
     * @param DateTimeInterface $value
     * @return $this
     */
    public function setTimestamp($value);

    /**
     * Get API status
     * @return boolean
     */
    public function getStatus();

    /**
     * Set API Status
     * @param $value
     * @return $this
     */
    public function setStatus($value);
}
