# Contributing to Phalcon Incubator

Phalcon Incubator is an open source project and a volunteer effort. Phalcon Incubator welcomes contribution from everyone.

Contributions to Phalcon Incubator should be made in the form of GitHub pull requests.
*We only accept bug reports, new feature requests and pull requests in GitHub*.

## Not All Commits Need CI Builds

Sometimes all you are changing is the README, some documentation or other things which have no effect on the tests.
In this case, you may not want a build to be created for that commit. To do this, all you need to do is to add `[ci skip]`
somewhere in the commit message.

Commits that have `[ci skip]` anywhere in the commit messages will be ignored. `[ci skip]` does not have to appear on the
first line, so it is possible to use it without polluting your project's history.

Alternatively, you can also use `[skip ci]`.

## Getting Support

For questions regarding the usage of the framework or support requests please visit the [official forums](http://forum.phalconphp.com/).

## Requesting Features

If you have a change or new feature in mind, please fill an [NFR](https://github.com/phalcon/cphalcon/wiki/New-Feature-Request---NFR).

Thanks! <br />
Phalcon Team
